	bits 32
	global _original_vista_wndproc
	global _my_vista_wndproc
	global _wndproc_intercept
	section .data
_original_vista_wndproc dd 0
_my_vista_wndproc dd 0	
	section .text
;;; 
;;; The wndproc intercept function
;;;
;;; This function calls our new wndproc before jumping to the old one
;;; 
_wndproc_intercept:
	;; push the 4 parameters on the stack
	
	;; the stack looks like this:
	;; [esp+4]  RET
	;; [esp+8]  hwnd
	;; [esp+12] msg
	;; [esp+16] wparam
	;;
	;; Since esp is decreased by 4 each time a dword is pushed,
	;; just push [esp+16] four times to push the original parameters
	;; 
	push	dword [esp+16]
	push	dword [esp+16]
	push	dword [esp+16]
	push	dword [esp+16]
	call	[_my_vista_wndproc]

	;; now jump to the original wndproc

	;; first do the stuff that was replaced by the jmp
	push	ebp
	mov	ebp, esp

	;; then calculate where to jump to 
	mov	eax, dword [_original_vista_wndproc]
	add	eax, 5 		; skip jmp-instruction

	;; and jump!
	jmp	eax


	